# *************************************************************************
#	File Name:		channel.tcl
# Package Name:	channel
# Version:      1.0
# Date:         Jan 26, 2001
# Description:	Channel Extension
#	License:			It is the same as Tcl BSD license.
#	Author:			Chang LI
# ************************************************************************

package provide channel 1.0

proc channel {cmd args} {

	switch -exact -- $cmd {

		open 	{
			switch -exact -- [lindex $args 0] {
				file {
					return [eval open [lrange $args 1 end]]
				}

				socket {
					return [eval socket [lrange $args 1 end] 
				}

				default {
					return error "unknown channel type!"
				}   
			}
		}

		close	{
			return [eval close $args]
		}

		configure {
			return [eval fconfigure $args]
		}

		blocked {
			return [eval fblocked $args]
		}

		fcopy {
			return [eval fcopy $args]
		}

		event {
			return [eval fileevent $args]
		}
 
		eof		{
			return [eval eof $args]
		}

		flush	{
			return [eval flush $args]
		}

		tell		{
					return [eval tell $args]
		}

		seek		{
					return [eval seek $args]
		}

		read		{
			return [eval read $args]
		}	

		write 	{
			return [eval puts $args]
		}

		default {
    		error "unknown command $command."
		}
	}
}